let
  fromEnv = var: def:
    let val = builtins.getEnv var; in
    if val != "" then val else def;
in rec {
  perl = "/nix/store/kh16fv1c81f64b3bz5cdqrjxnrkrpx4p-perl-5.20.2/bin/perl";
  shell = "/nix/store/fz5cv1c7jm8wf0hllp51izk0didjyvaq-bash-4.3-p42/bin/bash";
  coreutils = "/nix/store/xmlp6pyxi6hi3vazw9821nlhhiap6z63-coreutils-8.24/bin";
  bzip2 = "/nix/store/9qq1ija0vjpaf4yfqdd3g92q5xqsaixy-bzip2-1.0.6/bin/bzip2";
  gzip = "/nix/store/6d2bbf3zbkg96d4wmsp889a2p8p3z6zx-gzip-1.6/bin/gzip";
  xz = "/nix/store/hs8lf8v9qqfs9m3jqmm97nqg7wg9dqjw-xz-5.2.1/bin/xz";
  tar = "/nix/store/nrzwh9d5qdmi7jg6qb8i30xxcjpf1y5k-gnutar-1.28/bin/tar";
  tarFlags = "--warning=no-timestamp";
  tr = "/nix/store/xmlp6pyxi6hi3vazw9821nlhhiap6z63-coreutils-8.24/bin/tr";
  nixBinDir = fromEnv "NIX_BIN_DIR" "/nix/store/90rq3xc6xv5hn4cxm8br69iw5i74vmbn-nix-1.11/bin";
  nixPrefix = "/nix/store/90rq3xc6xv5hn4cxm8br69iw5i74vmbn-nix-1.11";

  # If Nix is installed in the Nix store, then automatically add it as
  # a dependency to the core packages. This ensures that they work
  # properly in a chroot.
  chrootDeps =
    if dirOf nixPrefix == builtins.storeDir then
      [ (builtins.storePath nixPrefix) ]
    else
      [ ];
}
